<template>
  <b-container>
    <b-alert v-if="hasConfigurationError" variant="danger" show :dismissible="true">
      Oops! Er is iets fout gegaan met het aanmaken van de configurator voor het gekozen product.
    </b-alert>
    <b-alert v-if="isConfigurationCompleted" variant="success" show :dismissible="true">
      Wohoo! Uw product is succesvol samengesteld voor &euro; {{getConfigurationPrice}}<br />
      Op dit moment is er nog geen mogelijkheid om uw samenstelling te bekijken.. :(
    </b-alert>

    <b-row>
      <b-col v-for="product in products" v-bind:key="product.reference">
        <b-col class="col-3 align-self-center">
          <div class="card" style="width: 18rem;">
            <img class="card-img-top" src="../../assets/img/rails.png" :alt="product.reference">
            <div class="card-body">
              <h5 class="card-title">{{product.name}}</h5>
              <p class="card-text">{{product.description}}</p>
              <button @click="startConfiguration(product.reference)" class="btn btn-success">
                Product samenstellen
              </button>
            </div>
          </div>
        </b-col>
      </b-col>
    </b-row>
    <b-row v-if="isConfigurationCreatePending">
      <b-col>
        <div class="spinner-border spinner-border-sm" role="status">
          <span class="sr-only">Laden..</span>
        </div>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import axios from "axios"
import {mapGetters} from "vuex";

import {CONF_CREATE_REQUEST} from "@/store/actions/configuration";

export default {
  name: 'Products',
  data() {
    return {
      products: []
    }
  },
  methods: {
    getProducts: function() {
      axios.get("/product/").then((response) => {
        this.products = response.data
      }).catch(error => {
        console.log("Unable to retrieve products", error)
      })
    },
    startConfiguration: function(productReference) {
      this.$store.dispatch(CONF_CREATE_REQUEST, {
        productReference
      }).then(() => {
        this.$router.push('/configuration');
      }).catch(error => {
        this.$set(this, 'errors', error.response.data)
      })
    }
  },
  computed: {
    ...mapGetters([
      'isConfigurationCreatePending',
      'hasConfigurationError',
      'isConfigurationCompleted',
      'getConfigurationPrice'
    ])
  },
  mounted() {
    this.getProducts()
  }
}
</script>

<style scoped>
</style>
